<?php if (have_posts()) : 
	add_filter('excerpt_length', 'sts_excerpt_length_large');
	add_filter('excerpt_more', 'sts_excerpt_more_blog');
	while (have_posts()) : the_post(); 
		$thumbnail = get_the_post_thumbnail($post->ID, 'post_thumb');
		?>
		<div class="section">
			<?php if (has_post_thumbnail() && get_meta("_thumbnail_id") && $thumbnail): ?>
				<div class="image">
					<a href="<?php the_permalink(); ?>">
						<?php echo $thumbnail; ?>
					</a>
				</div>
			<?php endif ?>		
			<div class="info">
				<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
				<?php the_excerpt(); ?>
				<p><a href="<?php the_permalink(); ?>">Continue Reading</a></p>
			</div>
			<div class="cl">&nbsp;</div>
		</div>
	<?php endwhile;
	remove_filter('excerpt_length', 'sts_excerpt_length_large');
	remove_filter('excerpt_more', 'sts_excerpt_more_blog');
	if (  $wp_query->max_num_pages > 1 ) : ?>
		<div class="navigation">
			<div class="alignleft"><?php next_posts_link(__('&laquo; Older Entries')); ?></div>
			<div class="alignright"><?php previous_posts_link(__('Newer Entries &raquo;')); ?></div>
		</div>
	<?php endif; ?>
	
<?php else : ?>
	<div class="section">
		<div class="info">
			<h2>Nothing Found</h2>
			<?php  
			if ( is_category() ) { // If this is a category archive
				printf("<p>Sorry, but there aren't any posts in the %s category yet.</p>", single_cat_title('',false));
			} else if ( is_date() ) { // If this is a date archive
				echo("<p>Sorry, but there aren't any posts with this date.</p>");
			} else if ( is_author() ) { // If this is a category archive
				$userdata = get_userdatabylogin(get_query_var('author_name'));
				printf("<p>Sorry, but there aren't any posts by %s yet.</p>", $userdata->display_name);
			} else if ( is_search() ) {
				echo("<p>No posts found. Try a different search?</p>");
			} else {
				echo("<p>No posts found.</p>");
			}
			get_search_form(); 
			?>
		</div>
		<div class="cl">&nbsp;</div>
	</div>
<?php endif; ?>